#
# ICMP ECHO search
#

# $Id: icmp_search.rb,v 1.1 2001/09/03 04:45:06 elca Exp $

require 'icmp'
require 'timeout'
include ICMPModule
include Socket::Constants

require 'util.rb'

class IcmpSearch
  def initialize(hosts)
    @hosts = hosts
    @sock = ICMPSocket.new
    @packets = []

    @hosts.each {|i|
      sockaddr = ICMPModule::make_sockaddr_in(AF_INET, 0, i)

      j = ICMP.new
      j.icmp_type = ICMP_ECHO
      j.icmp_code = 0
      j.icmp_id = rand(65536)
      j.icmp_seq = 1
      j.icmp_data = [ Time.now.to_f ].pack("d")
      j.setup

      @packets += [{
	  "addr" => i,
	  "sockaddr" => sockaddr,
	  "packet" => j
	}]
    }

    #p @packets
  end

  def search(num)
    ret = []

    if num >= @packets.size
      return @hosts
    end

    @packets.each {|i|
      begin
	@sock.send(i["packet"], 0, i["sockaddr"])
      rescue
	# do nothing
      end
    }

    1.upto(5) {|j|
      buf = nil
      begin
	timeout(5){ buf = @sock.recv(65535) }
      rescue TimeoutError
	next
      end
      iph, repl = ICMPModule.split(buf)

      #p iph
      #p repl


      @packets.each {|i|
	if repl.icmp_type == ICMPModule::ICMP_ECHOREPLY &&
	    repl.icmp_id == i["packet"].icmp_id &&
	    iph[12,4] == i["addr"]
	  ret += [i["addr"]]
	  break
	end
      }

      if ret.size == num
	return ret
      end
    }

    return nil

  end

  def close()
    @sock.close
  end

end

#i = IcmpSearch.new([str_to_ipstr("192.168.0.1"), str_to_ipstr("127.0.0.1")])
#p i.search(4)

# end
